#--------------------------------------------
"""
PoserPythonReceiver.py
Version 1.16
1/14/2005
Poser Libary Load Python Utility
Copyright 2004, 2005, by Kenneth R. Mort (TromNek)


PLEASE READ THE SECURITY NOTE! (following this introduction)

This small utility loads a poser library file name (cm2, fc2, cr2, hr2, hd2, lt2, pz2, pp2)
and their compressed flavors from either the system clipboard or thru a network socket.

It can also open new documents (.pz3 files) but only their uncompressed flavor because
poser doesn't have a method for a python script to load compressed (.pzz) documents.

It is also able to run python scripts (.py ). However, if that python script
opens a window (GUI), then when that window is closed, this (PoserPythonReceiver.py) script
will 'crash'. If this occurs, close this ('crashed' PoserPythonReceiver.py) script and
restart it to resume normal operations.

Python script execution also has inherent security risks, please read the security note.
Users wishing allow python script execution need to enable it using the checkbox provided.

To use the System Clipboard method:
  You need to have the entire path name pasted into the clipboard, then click on
  the "Load" button to execute the poser library file currently in the system clipboard.
  There are a number of utilities to paste a path name into the clipboard.
  I use (the free) 'Copy Path Context Extension';
    http://www.codeproject.com/shell/copypathext.asp
    written by Nick Carruthers.
  The Power Toys (also free) 'SendToX' also works fine.

To use the Network Socket method:
  The simplist way is to get P3dO Explorer and the PoserPython plug-in by Seno Software
  (http://www.senosoft.com/).
  Their plug-in greatly simplifies the setup process.

  or

  If you know python and have the standard python distribution installed, this script
  can also be used as the 'sender' of filenames outside of poser. Look at the first 'if'
  statement in class App to understand how this is accomplished.

My main use of this utility is in conjuction with (the free) P3dO Explorer by Seno Software.
This lets me browse library directories quickly using P3dO then load them to poser.
P3dO also lets me open up multiple instances of the browser so I can have many library
directories open at the same time.

Have fun,
TromNek (you might find me http://www.renderosity.com/members.ez )

SECURITY NOTE:
Python script execution has inherent security risks.
Users wishing allow python script execution need to enable it using the checkbox provided.

This script opens a tcp/ip socket on the loopback (lo) network interface. Then it
listens for a connection that will deliver a file name to be loaded.
It will only accept a connection from the loopback interface so it is pretty
safe from attacks that may come from the internet or your local network.
However, if a virus or trojan infects your computer, it could send data over
your local loopback interface to this script.
Since this script supports the execution of other python scripts, a virus or trojan
that targets this feature can present a security risk.


"""
#--------------------------------------------
import site
import string
from os.path import *
from Tkinter import *
import tkMessageBox
from socket import *
if len(sys.argv) < 2:
  try:
    import poser
    scene = poser.Scene()
  except:
    scene = None

HOST = "127.0.0.1"
PORT = 49160
BUFSIZE = 1024

#print 'python', sys.version, ' tk', TkVersion
#-----------------------------------------------------------------------------
class App:
    def __init__(self, master, textMessage):
      global sock

      if len(sys.argv) >= 2:
        command = string.join(sys.argv[1:], "\n")
        sock = socket(AF_INET, SOCK_STREAM)
        sock.connect(( HOST, PORT))
        sock.send(command)
        sock.shutdown(1)
        sys.exit(0)
      else:
        sock = socket(AF_INET, SOCK_STREAM)
        sock.bind(( HOST, PORT))
        sock.listen(1)
        sock.setblocking(0)

      self.master = master
      master.title("TromNek's Library Executor")

      # Allow Python Scripts On/Off check button.
      self.PythonOn = IntVar()
      self.PythonOn.set( 0 )
      #self.buttonPython = Checkbutton(self.master, text="Enable remote python script execution", anchor=E, variable=self.PythonOn )
      self.buttonPython = Label(self.master, text="No remote python script execution", anchor=E )
      self.buttonPython.grid(row=1, column=0)

      #self.buttonGo = Button(self.master, text="Load from Clipboard", command=self.handleGo)
      #self.buttonGo.grid(row=1, column=2)

      self.master.protocol('WM_DELETE_WINDOW', self.handleCancel)

    def handleGo2(self, event):
      self.handleGo()

    def handleGo(self):
      try:
        inStr = root.selection_get(selection = "CLIPBOARD")
      except:
        tkMessageBox.showerror( "Clipboard Error, Arrrrggggg!", "You need a filename with path in the clipboard." )
        return
      outList = self.processArgs( inStr )
      self.handleFnList( outList )

    def processArgs(self, inStr):
      outList = []
      outList = string.split(inStr, "\n" )
      return outList

    def handleFnList(self, tmpstr):
      #print "\nhandleString:", tmpstr, "\n"
      for fn in tmpstr :
        a, b = splitext( fn )
        ok=1
        if isfile( fn ) :
          b = string.lower( b )
          if not scene.CurrentFigure() and b in ( ".fc2", ".fcz", ".hr2", ".hrz", ".hd2", ".hdz", ".pz2", ".p2z" ):
            tkMessageBox.showerror( "No figure is selected!",
                                    "Select a figure before loading.")
            continue
          if   b in ( ".cm2", ".cmz" ) :
            try: scene.LoadLibraryCamera( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b in ( ".fc2", ".fcz" ) :
            try: scene.LoadLibraryFace( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b in ( ".cr2", ".crz" ) :
            try: scene.LoadLibraryFigure( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b in ( ".hr2", ".hrz" ) :
            try: scene.LoadLibraryHair( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b in ( ".hd2", ".hdz" ) :
            if tkMessageBox.askyesno("Choose", "Right Hand?") :
              try: scene.LoadLibraryHand( fn, 0 )
              except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
            else :
              try: scene.LoadLibraryHand( fn, 1 )
              except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b in ( ".lt2", ".ltz" ) :
            try: scene.LoadLibraryLight( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b in ( ".pz2", ".p2z" ) :
            try: scene.LoadLibraryPose( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b in ( ".pp2", ".ppz" ) :
            try: scene.LoadLibraryProp( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          elif b[0:3] == ".py" :
          #  if self.PythonOn.get():
          #    try: poser.ExecFile( fn )
          #    except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          #  else:
          #    tkMessageBox.showerror( "Remote Python Script Execution Not Enabled!",
          #                            "Use the 'Enable remote python script execution' checkbox to enable.")
            tkMessageBox.showerror( "Remote Python Script Execution Not Allowed!",
                                    "This version of PoserPythonReceiver.py does not allow remote python script execution.")
          elif b == ".pz3" :
            try: poser.CloseDocument()
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
            try: poser.OpenDocument( fn )
            except: tkMessageBox.showerror( "CL Poser-Python Exception", "Poser didn't like file;\n" + fn )
          else:
            ok=0
            print "FAIL: Non Supported Filetype=> '", b, "'"
        else:
          ok=0
          print "FAIL: File Does Not Exist=>", fn

        if ok:
          pass

    def check_conn(self):
      try:
        conn, (remotehost, remoteport) = sock.accept()
      except:
        return
      #print 'connected by', remotehost, remoteport
      if remotehost == "127.0.0.1":
        request = ''
        while 1:
          data = conn.recv(BUFSIZE)
          if not data:
            break
          request = request + data
        outList = self.processArgs( request )
        self.handleFnList( outList )
        conn.close()
      else:
        conn.close()
        print "closed-denied connection from:", remotehost

    def handleCancel(self):
        self.master.destroy()

    def Update(self):
        self.check_conn()
        if scene: scene.ProcessSomeEvents()
        root.lift()
        root.after(50, self.Update)


#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#------------------------------------------------------------
